#pragma once

/*!
 * \class ComboNtp
 *
 * \brief 
     CEdit   CComboBoxEx 
    ComboNtp  :
 BOOL CMainDlg::PreTranslateMessage(MSG* pMsg)
 {
	 if (pMsg->message == WM_KEYDOWN && (pMsg->wParam == VK_RETURN || pMsg->wParam == VK_DELETE) )
	 {
		 CEdit ed = m_box.GetEditCtrl();
		 if (pMsg->hwnd == ed.m_hWnd)
		 {
			 MSG msg = { m_hWnd, WM_KEYDOWN, pMsg->wParam, pMsg->lParam, 0, { 0, 0 } };
			 LRESULT lRet = SendMessage(m_box.m_hWnd, WM_FORWARDMSG, 0, (LPARAM)&msg);
		 }
		 return 0;
	 }
	return CWindow::IsDialogMessage(pMsg);
 }

 *
 * \author Alexandr Levchuk
 * \date  2019
 */
class ComboNtp :public CWindowImpl< ComboNtp, CComboBoxEx>
{
public:
	DECLARE_WND_CLASS(NULL)

	ComboNtp(void)
	{}
	virtual ~ComboNtp(void)
	{}

	BEGIN_MSG_MAP_EX(ComboNtp)
		MESSAGE_HANDLER_EX(WM_FORWARDMSG, OnForward)
	END_MSG_MAP()

	LRESULT OnForward(UINT nMsg, WPARAM wParam, LPARAM lParam)
	{
		SetMsgHandled(FALSE); // TRUE   
		MSG* pMsg = (MSG*)lParam;
		if (pMsg->wParam == VK_RETURN) cbEditString();
		else if (pMsg->wParam == VK_DELETE) cbDeleteString();

		return 0;
	}

	void InitCombo()
	{
		addString(L"0.ru.pool.ntp.org",0);
		addString(L"1.ru.pool.ntp.org",1);
		addString(L"2.ru.pool.ntp.org",2);
		addString(L"0.ua.pool.ntp.org",5);
		addString(L"1.ua.pool.ntp.org",6);
		addString(L"2.ua.pool.ntp.org",7);
		addString(L"ntp.time.in.ua",3);
		addString(L"ntp1.inrim.it",4);
	}

private:
	void addString(LPCTSTR lpszString, int iItem = 0)
	{
		COMBOBOXEXITEM combo = { 0 };
		combo.mask = CBEIF_TEXT;
		combo.iItem = iItem;
		combo.pszText = const_cast<LPWSTR>(lpszString);
		combo.iIndent = 1;
		InsertItem(&combo);
	}


	/**************************************************************************
	* Method:    EditString
	* Description         .
		  VK_RETURN.
	* Returns:   void
	***************************************************************************/
	void cbEditString()
	{
		CEdit ed = GetEditCtrl();
		int idx = GetCurSel();
		if (idx == -1)
			idx = 0;

		wstring s;
		int len = ed.LineLength(ed.LineIndex(idx));
		s.resize(len);
		ed.GetLine(idx, const_cast<WCHAR*>(s.c_str()), len);
		if (!s.empty())   addString(s.c_str(), 0);
	}

	/**************************************************************************
	* Method:    cbDeleteString
	* Description     Delete.
	* Returns:   void
	***************************************************************************/
	void cbDeleteString()
	{
		int idx = GetCurSel();
		DeleteString(idx);
	}

public:
	wstring cbGetAddressNtp()
	{
		int idx = GetCurSel();
		if (idx == -1)
		{
			idx = 0;
			SetCurSel(idx);
		}

		WCHAR buf[64] = { 0 };
		GetItemText(idx, buf, 64);
		return wstring(buf);
	}
};


